package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.OrgUser;

/**
 * 实体[ZB] 数据对象
 */
@TableName(value = "T_ZB",resultMap = "ZBResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class ZB extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private OrgUser orguser;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String orguserid;
    @TableField(exist = false)//逻辑属性
    private String orgusername;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "zbid",type=IdType.UUID)//指定主键生成策略
    private String zbid;
    private String zbname;
    private Timestamp zbsj;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[组织人员标识]
     *  @param orguserid
     */
    public void setOrguserid(String orguserid){
        if(StringUtils.isEmpty(orguserid))
            orguserid=null;
        this.orguserid = orguserid;
        this.set("orguseriddirtyflag",true);
    }
    /**
     *  获取属性值[组织人员标识]
     */
    public String getOrguserid(){
        return this.orguserid;
    }
    /**
     *  重置属性值[组织人员标识]
     */
    public void resetOrguserid(){
        this.set("orguseriddirtyflag",false);
        this.orguserid = null;
    }
    /**
     *  设置属性值[值班人员]
     *  @param orgusername
     */
    public void setOrgusername(String orgusername){
        if(StringUtils.isEmpty(orgusername))
            orgusername=null;
        this.orgusername = orgusername;
        this.set("orgusernamedirtyflag",true);
    }
    /**
     *  获取属性值[值班人员]
     */
    public String getOrgusername(){
        return this.orgusername;
    }
    /**
     *  重置属性值[值班人员]
     */
    public void resetOrgusername(){
        this.set("orgusernamedirtyflag",false);
        this.orgusername = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[值班标识]
     *  @param zbid
     */
    public void setZbid(String zbid){
        if(StringUtils.isEmpty(zbid))
            zbid=null;
        this.zbid = zbid;
        this.set("zbiddirtyflag",true);
    }
    /**
     *  获取属性值[值班标识]
     */
    public String getZbid(){
        return this.zbid;
    }
    /**
     *  重置属性值[值班标识]
     */
    public void resetZbid(){
        this.set("zbiddirtyflag",false);
        this.zbid = null;
    }
    /**
     *  设置属性值[值班名称]
     *  @param zbname
     */
    public void setZbname(String zbname){
        if(StringUtils.isEmpty(zbname))
            zbname=null;
        this.zbname = zbname;
        this.set("zbnamedirtyflag",true);
    }
    /**
     *  获取属性值[值班名称]
     */
    public String getZbname(){
        return this.zbname;
    }
    /**
     *  重置属性值[值班名称]
     */
    public void resetZbname(){
        this.set("zbnamedirtyflag",false);
        this.zbname = null;
    }
    /**
     *  设置属性值[值班时间]
     *  @param zbsj
     */
    public void setZbsj(Timestamp zbsj){
        this.zbsj = zbsj;
        this.set("zbsjdirtyflag",true);
    }
    /**
     *  获取属性值[值班时间]
     */
    public Timestamp getZbsj(){
        return this.zbsj;
    }
    /**
     *  重置属性值[值班时间]
     */
    public void resetZbsj(){
        this.set("zbsjdirtyflag",false);
        this.zbsj = null;
    }
     /**
     *  获取主实体关联数据[OrgUser]
     */
    public OrgUser getOrguser() {
        return orguser;
    }
    /**
     *  设置主实体关联数据[OrgUser]
     */
    public void setOrguser(OrgUser orguser) {
        this.orguser = orguser;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetOrguserid();
        resetOrgusername();
        resetUpdatedate();
        resetUpdateman();
        resetZbid();
        resetZbname();
        resetZbsj();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public ZB copyTo(ZB targetEntity)
	{
		BeanCopier copier=BeanCopier.create(ZB.class, ZB.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetZbid();
		return targetEntity;
	}
}